--FIXED:
--
--BUG: init, delete monitor track -> tries to access the track, bugs out.
--not always so
--BUG(same as above?): init, add device to monitor track, have monitor devices GUI open, delete monitor track -> bugs out
--
--BUG: when skipping between tracks with monitor device on, move right towards master, move one track back,
--no send device appears. Also happens when moving right.
--
--
--DONE:
--
--Follow selected track
----attach the create send into selected track observable
--if performance gets shot, attach to idle loop
--
--metering configurations
--store metering confs, like open plugin guis, ACTive preset data!
--
--TODO:
--option for the renoise upper tab behavior:
--no change
--master spectrum
--track scopes
--master scopes
--?
--
--
--TODO:
--Cleanup. Messy and partly obfuscated.
--
--
--
--[[============================================================================
main.lua
============================================================================]]--

-- Placeholder for the dialog
local dialog = nil

-- Placeholder to expose the ViewBuilder outside the show_dialog() function
local vb = nil

-- Reload the script whenever this file is saved. 
-- Additionally, execute the attached function.
_AUTO_RELOAD_DEBUG = function()
  
end

-- Read from the manifest.xml file.
class "RenoiseScriptingTool" (renoise.Document.DocumentNode)
  function RenoiseScriptingTool:__init()    
    renoise.Document.DocumentNode.__init(self) 
    self:add_property("Name", "Untitled Tool")
    self:add_property("Id", "Unknown Id")
  end

local manifest = RenoiseScriptingTool()
local ok,err = manifest:load_from("manifest.xml")
local tool_name = manifest:property("Name").value
local tool_id = manifest:property("Id").value

--------------------------------------------------------------------------------
-- Tool Options
--------------------------------------------------------------------------------
-- Setup the preferences Document
local preferences = renoise.Document.create("ScriptingToolPreferences"){
    my_monitor_chain = {
        device_1 = {
            device_path = "",
            active_preset_data = ""
        },
        device_2 = {
            device_path = "",
            active_preset_data = ""
        },
        device_3 = {
            device_path = "",
            active_preset_data = ""
        },
        device_4 = {
            device_path = "",
            active_preset_data = ""
        },
        device_5 = {
            device_path = "",
            active_preset_data = ""
        },
        device_6 = {
            device_path = "",
            active_preset_data = ""
        },
        device_7 = {
            device_path = "",
            active_preset_data = ""
        },
        device_8 = {
            device_path = "",
            active_preset_data = ""
        },
        device_9 = {
            device_path = "",
            active_preset_data = ""
        },
        device_10 = {
            device_path = "",
            active_preset_data = ""
        },
    },
}
renoise.tool().preferences = preferences

--------------------------------------------------------------------------------
-- Main functions
--------------------------------------------------------------------------------
--A table to store the devices that go into monitor track
local monitor_dsp_chain = nil

--Variables to hold the names of monitor track and device
local unique_monitor_send_track_name = "__MNTR__"
local unique_monitor_send_device_name = "__TO_MNTR__"

--Option flags
local follow_selected_track = true

--Global vars
local current_track = 1
local is_active = false

--Placeholder for an idler function
local idle_update = function()
    --placeholder, is actually defined later
end

local function boot()
    --[[
    This is ran whenever a new song is loaded
    --]]
    monitor_dsp_chain = nil
    if not renoise.tool().app_idle_observable:has_notifier(idle_update) then
        renoise.tool().app_idle_observable:add_notifier(idle_update)
    end
end

local function unload()
    --[[
    This is ran whenever a song is closed
    --]]
    if renoise.tool().app_idle_observable:has_notifier(idle_update) then
        renoise.tool().app_idle_observable:remove_notifier(idle_update)
    end
end

--Register notifiers to run the above functions
if not renoise.tool().app_new_document_observable:has_notifier(boot) then
    renoise.tool().app_new_document_observable:add_notifier(boot)
end
if not renoise.tool().app_release_document_observable:has_notifier(unload) then
    renoise.tool().app_release_document_observable:add_notifier(unload)
end

local function get_monitor_track()
    --[[
    This finds the monitor track in song()
    returns the track object, track index
    or nil, nil, if can't find them
    --]]
    local monitor_track, monitor_track_index

    for index, track in pairs(renoise.song().tracks) do
        if track.name == unique_monitor_send_track_name then
            monitor_track = track
            monitor_track_index = index
            break
        end
    end

    return monitor_track, monitor_track_index
end

local function get_monitor_device(track_index)
    --[[
    This finds the monitor send device in track
    returns the device object, device index
    or nil, nil, if can't find them
    --]]
    local monitor_device, monitor_device_index

    local is_there = false
    for index, device in pairs(renoise.song():track(track_index).devices) do
        if device.display_name == unique_monitor_send_device_name then
            monitor_device = device
            monitor_device_index = index
            is_there = true
            break
        end
    end

    if not is_there then
        print("No monitor device was found in track")
    end

    return monitor_device, monitor_device_index
end

local function create_monitor_send_device(track_index)
    --[[
    This function creates the monitor send device in the track(track_index)
    --]]
    --Template (send device option "mute/keep source" inaccessible through lua otherwise than active_preset_data)
    local senddevicetemplate = [[
<?xml version="1.0" encoding="UTF-8"?>
<FilterDevicePreset doc_version="9">
  <DeviceSlot type="SendDevice">
    <IsMaximized>false</IsMaximized>
    <SendAmount>
      <Value>1.0</Value>
    </SendAmount>
    <SendPan>
      <Value>0.5</Value>
    </SendPan>
    <DestSendTrack>
      <Value>5</Value>
    </DestSendTrack>
    <MuteSource>false</MuteSource>
    <SmoothParameterChanges>true</SmoothParameterChanges>
  </DeviceSlot>
</FilterDevicePreset>
]]
    --First: check that this is not master track
    --(Sends cannot be created in master)
    if renoise.song():track(track_index).type == renoise.Track.TRACK_TYPE_MASTER then
        --One simply does not create a send device on master
        --Set relevant tool global flags anyway
        current_track = track_index
        --print("master track - cannot create send")
        return false
    end

    --Do a basic check that monitor track exists!
    --If there's no track to send, to, no use to create the send device
    local monitor_track, monitor_track_index = get_monitor_track()
    if not monitor_track then
        --Set relevant tool global flags anyway
        current_track = track_index
        --print("Could not create monitor send - no monitor track!")
        return false
    end

    --Past basic checks! YAY!
 
    --Init variables for this function
    local monitor_send_device = nil
    local monitor_send_device_index = nil

    --Do a check if the device IS already there
    --(for some weird reason)
    local this_track = renoise.song():track(track_index)
    local is_there = false
    for index, device in pairs (this_track.devices) do
        if device.display_name == unique_monitor_send_device_name then
            is_there = true
            monitor_send_device = device
            monitor_send_device_index = index
            break
        end
    end 
    if is_there then
        --don't create it
        print("Didn't create monitor send - already there.")
        return false
    else
        --create it!
        --Check WHERE to create the device inside the chain.
        local last_device, device_index = get_last_outgoing_device(track_index)
        if device_index == 1 then 
            --It's the postfx volume device
            --Set this send to last place.
            --This needs to be set here, because the postfx device
            --ACTUALLY is the first device in chain, in renoise logic.
            device_index = #this_track.devices + 1
        end
        --Actually create teh device now
        --First: this is the device to put there:
        local device_path = "Audio/Effects/Native/#Send"
        --And now put it there. Reference it with "monitor_send_device".
        monitor_send_device = this_track:insert_device_at(device_path, device_index)
        --Name the device
        monitor_send_device.display_name = unique_monitor_send_device_name
        --Check that creating went ok
        if not monitor_send_device then
            --print("Something went wrong creating the device")
            return false
        else
            --Creating went ok
            --print("Created monitor send device")
        end
    end

    --Painfully set the 'keep source option', minimize device
    monitor_send_device.active_preset_data = senddevicetemplate

    --Adjust send target correctly
    local send_track_index_start = #renoise.song().tracks - renoise.song().send_track_count + 1
    monitor_send_device:parameter(3).value = monitor_track_index - send_track_index_start
     
    --Set tool global flags
    current_track = track_index
    is_active = true

    return monitor_send_device, monitor_send_device_index
end

local function delete_monitor_send_device(track_index)
    --[[
    This function removes the (tool-inserted) send device from
    track (track_index)
    --]]
    
    --if track_index is not the monitor send track, exit!
    --also if track_index > #renoise.song().tracks
    --(the likely scenario is that user deleted
    --the monitor send track by hand)
    if track_index > #renoise.song().tracks then
        return
    end

    --Now find device
     
    --Init some variables
    local monitor_device
    local monitor_device_index

    --Get a reference to this track
    local this_track = renoise.song():track(track_index)

    --Check if the device is there?
    local is_there = false
    for index, device in pairs(this_track.devices) do
        if device.display_name == unique_monitor_send_device_name then
            is_there = true
            monitor_device = device
            monitor_device_index = index
            break
        end
    end

    local message = ""
    if is_there then
        --Found it -> delete
        this_track:delete_device_at(monitor_device_index)
        message = "Deleted monitor device"
    else
        --Can't delete
        message = "Could not delete monitor device (not found)"
        return false
    end

    --print(message)
    return true
end

local function get_devices(track_index)
    --[[
    This helper just returns a COPY of the track's devices table
    --]]
    return table.copy(renoise.song():track(track_index).devices)
end

local function store_devices(track_index)
    --[[
    This helper prunes a valid device chain to store as the
    global "monitor_dsp_chain"
    Also takes care of storing the chain to the preferences
    --]]
    --First, get the device list (copy)
    monitor_dsp_chain = get_devices(track_index)
    --Then validate
    --validate by removing any monitor sends from that list
    for index, device in pairs (monitor_dsp_chain) do
        if device.display_name == unique_monitor_send_device_name then
            table.remove(monitor_dsp_chain, index)
        end
    end
    --Now valid
    --Store in preferences
    for index = 1, 10 do
        local device_name = "device_"..index
        local this_device = monitor_dsp_chain[index+1]
        if this_device then
            --wirte device in preferences
            preferences.my_monitor_chain[device_name].device_path.value = this_device.device_path
            preferences.my_monitor_chain[device_name].active_preset_data.value = this_device.active_preset_data
        else
            --write nulls in preferences
            preferences.my_monitor_chain[device_name].device_path.value = ""
            preferences.my_monitor_chain[device_name].active_preset_data = ""
        end
    end
    --print("Stored track "..track_index.." dsp chain as monitor chain")
end

local function create_monitor_send_track()
    --[[
    Does what it says on the label. So this creates
    the send track which acts as the "Monitor track".
    --]]

    --A function to set any track properties of the created track
    local function set_monitor_track_props(monitor_track)
        --set postfx gain to zero
        monitor_track.postfx_volume.value = 0

        --set visuals
        monitor_track.color = {0xFF,0xFF,0xFF}
        monitor_track.color_blend = 100
    end

    --[[
    Out of date! No need to check this anymore

    --First check if monitor_dsp_chain is empty
    local monitor_dsp_chain_exists = false

    if not monitor_dsp_chain then
        --try to find the track and get that chain
        local is_there = false
        local monitor_track
        local monitor_track_index
        for index, track in pairs(renoise.song().tracks) do
            if track.name == unique_monitor_send_track_name then
                is_there = true
                monitor_track = track
                monitor_track_index = index
                break
            end
        end
        if is_there then
            --get that device chain
            monitor_dsp_chain_exists = true
            store_devices(monitor_track_index)
        end
    else
        monitor_dsp_chain_exists = true
    end
    --]]

    --[[
    if not monitor_dsp_chain_exists then
        renoise.app():show_status("Cannot create Monitor send - no DSP chain stored")
        return false
    end
    --]]

    local message = ""

    local monitor_track
    local monitor_track_index

    --check if monitor track exists?
    local is_there = false
    --Seek it by name
    for index, track in pairs(renoise.song().tracks) do
        if track.name == unique_monitor_send_track_name then
            is_there = true
            monitor_track = track
            monitor_track_index = index
            break
        end
    end
    if is_there then
        --no need to create it
        message = message.."Updated the monitor track"
        --set /update props
        set_monitor_track_props(monitor_track)    
        return false
    else
        --create it at last place
        local last_track_index = #renoise.song().tracks + 1
        monitor_track = renoise.song():insert_track_at(last_track_index)
        monitor_track_index = last_track_index
        monitor_track.name = unique_monitor_send_track_name
        message = message.."Created the monitor track"
    end

    --create dsp chain
    local mt_devices = table.copy(monitor_track.devices)

    --remove current devices
    for index = 2, #mt_devices do 
        monitor_track:delete_device_at(2)
    end
    message = message.." - Deleted "..(#mt_devices - 1).." devices"
    --restore devices from preferences
    for index = 1, 10 do
        local device_name = "device_"..index
        local this_node = preferences.my_monitor_chain[device_name]
        if this_node.device_path.value == "" then
            --ran out of devices
            break
        else
            local device_path = this_node.device_path.value
            local active_preset_data = this_node.active_preset_data.value
            --insert
            local new_device = monitor_track:insert_device_at(device_path, index+1)
            --set data
            new_device.active_preset_data = active_preset_data

        end
    end
    --Store in global (needed?)
    monitor_dsp_chain = get_devices(monitor_track_index)
    message = message.." - Created "..(#monitor_dsp_chain - 1).." devices"

    --[[
    --add monitor dsp chain devices
    if monitor_dsp_chain then
        for index = 2, #monitor_dsp_chain do 
            monitor_track:insert_device_at(monitor_dsp_chain[index].device_path, index)
        end
        --set monitor dsp chain parameters
        for device_index = 2, #monitor_dsp_chain do
            local this_device = monitor_dsp_chain[device_index]
            for parameter_index, parameter in pairs(this_device.parameters) do
                monitor_track:device(device_index):parameter(parameter_index).value = parameter.value
            end
        end
        message = message.." - Created "..(#monitor_dsp_chain - 1).." devices"
    else
        message = message.." - Empty device chain"
    end
    --]]

    --set other track properties
    set_monitor_track_props(monitor_track)    

    --debug
    renoise.app():show_status(message)

    return monitor_track, monitor_track_index
end

function open_monitor_plugin_guis()
    --[[
    This runs through the monitor track devices and opens external
    GUIs for yer monitoring needs
    --]]
    local monitor_track, monitor_track_index = get_monitor_track()
    if not monitor_track then 
        --track not there
        return false
    end
    local devices = monitor_track.devices
    for device_index, device in pairs(devices) do
        if device.external_editor_available then
            device.external_editor_visible = true
        end
    end
end

function close_monitor_plugin_guis()
    --[[
    This closes all external GUIs in devices found on the monitor track.
    --]]
    local monitor_track, monitor_track_index = get_monitor_track()
    if not monitor_track then 
        --track not there
        return false
    end
    local devices = monitor_track.devices
    for device_index, device in pairs(devices) do
        if device.external_editor_available then
            device.external_editor_visible = false
        end
    end
end

local function delete_monitor_send_track()
    --[[
    This deletes the monitor send track. It's part
    of the "exit" bindable function which removes
    all crap left by the tool.
    --]]

    --Find the monitor track
    
    --Init some vars for that
    local monitor_track
    local monitor_track_index

    --Seek it out
    local is_there = false
    for index, track in pairs(renoise.song().tracks) do
        if track.name == unique_monitor_send_track_name then
            is_there = true
            monitor_track = track
            monitor_track_index = index
            break
        end
    end

    local message = ""

    --Before deleting, store current track index
    --so that it can be restored after the delete
    local current_index = renoise.song().selected_track_index

    if is_there then
        --Before closing, store current dsp chain with active preset data too
        store_devices(monitor_track_index)
        --Done, delete
        renoise.song():delete_track_at(monitor_track_index)
        message = "Deleted monitor track"
    else
        --Wasn't found. Can't delete.
        message = "Could not delete monitor track (not found)"
    end

    --Done, return cursor to previously selected track index
    if current_index > #renoise.song().tracks then
        --The deletion occured when the cursor was ON the monitor track
        --No need to change cursor
    else
        --Move the cursor
        renoise.song().selected_track_index = current_index
    end

    --Set monitor_dsp_chain to nil
    monitor_dsp_chain = nil

    --debug
    --print(message)
    return true
end

local function show_renoise_metering()
    --[[
    Just a 'quickie' shorthand to switch the upper frame to show renoise metering
    --]]
    --renoise.ApplicationWindow.UPPER_FRAME_DISK_BROWSER
    --renoise.ApplicationWindow.UPPER_FRAME_TRACK_SCOPES
    --renoise.ApplicationWindow.UPPER_FRAME_MASTER_SCOPES
    --renoise.ApplicationWindow.UPPER_FRAME_MASTER_SPECTRUM
    renoise.app().window.active_upper_frame = renoise.ApplicationWindow.UPPER_FRAME_MASTER_SPECTRUM
end

local function move_send_track_to_last_place()
    --[[
    What it says in the label.
    (moves the send track to last place)
    --]]
    --Check if the track is there
    local send_track, send_track_index = get_monitor_track()
    if not send_track then
        --Can't move. Return.
        return false
    end
    --Check if last
    local track_count = #renoise.song().tracks
    if send_track_index == track_count then
        --Already is last
        return false
    end
    --Not last -> Move (one by one)
    local swaps = track_count - send_track_index
    for i = 1, swaps do
        renoise.song():swap_tracks_at(send_track_index + i - 1, send_track_index + i)
    end
end

local function move_send_device_to_last_place(track_index)
    --[[
    This moves the send device in the last "outgoing" place in
    the current track's device chaine
    TODO: NOT SO, this does nothing to check the last OUTGOING device.
    Currently not used anywhere!

    --]]
    --moves the send device to last place
    --Check if there 
    local send_device, send_device_index = get_monitor_device(track_index)
    local this_track = renoise.song():track(track_index)
    if not send_device then
        return false
    end
    print("sdi "..send_device_index)
    --Check if last
    local device_count = #this_track.devices
    print("dc "..device_count)
    if send_device_index == device_count then
        --is last
        return false
    end
    --Move
    local swaps = device_count - send_device_index
    for i = 1, swaps do
        this_track:swap_devices_at(send_device_index + i - 1, send_device_index + i)
        print("swap "..i)
    end
    print("moved!")
end


--------------------------------------------------------------------------------
-- Keybind functions
--------------------------------------------------------------------------------

local function init()
    --[[
    THE main bindable function. This will act as a toggle.
    First time pressed: will create the monitor track if not there,
    and the monitor send device for current track. After this user
    can put the devices in monitor track.
    Second time (toggling) will close monitor track plugin GUIs,
    and remove send device.
    Another press will just toggle monitor track devices open and
    insert the send device on current track.
    --]]
    --Create send track
    local success = create_monitor_send_track()
    --if this track has send, exit() (=Toggle behaviour)
    local send_device, send_device_index = get_monitor_device(renoise.song().selected_track_index)
    if send_device then
        --update monitor device chain
        local monitor_track, monitor_track_index = get_monitor_track()
        store_devices(monitor_track_index)
        --exit
        delete_monitor_send_device(renoise.song().selected_track_index)
        close_monitor_plugin_guis()
        --set globals
        is_active = false
        return
    end
    --Create send device, connect
    --first remove old send
    local success = false
    local old_send_device_track_index = nil
    local old_send_device_index = nil
    for track_index, track in pairs(renoise.song().tracks) do
        local send_device, send_device_index = get_monitor_device(track_index)
        if send_device then
            --remove old send
            success = true
            old_send_device_track_index = track_index
            old_send_device_index = send_device_index
            break
        end
    end
    if success then
        renoise.song():track(old_send_device_track_index):delete_device_at(old_send_device_index)
    end
    --Create new send
    local success = create_monitor_send_device(renoise.song().selected_track_index) 
    --open guis
    if success then
        open_monitor_plugin_guis()
        is_active = true
    else
        close_monitor_plugin_guis()
        is_active = false
    end
    --show renoise metering
    show_renoise_metering()
end

local function exit()
    --[[
    The main bindable exit function
    This removes the track and all other
    residue left by the tool. Scenario:
    I'm done with the song, Want to scrape out
    all the crap left by this tool.
    --]]
    --close monitor plugin guis
    close_monitor_plugin_guis()
    --find send device, delete it
    local success = false
    for index, track in pairs(renoise.song().tracks) do
        success = delete_monitor_send_device(index)
        if success then
            break
        end
    end
    --[[
    if not success then
        --delete send track
        delete_monitor_send_track()
    end
    --]]
    delete_monitor_send_track()
end

--------------------------------------------------------------------------------
-- Helpers
--------------------------------------------------------------------------------
function print_devices()
    local devices = get_devices(renoise.song().selected_track_index)
    --rprint(devices)
    for index, device in ipairs(devices) do
        print("device.name")
        print(device.name)
        print("device.display_name")
        print(device.display_name)
        print("device.is_active")
        print(device.is_active)
        print("device.is_maximized")
        print(device.is_maximized)
        print("device.active_preset")
        print(device.active_preset)
        print("device.active_preset_data")
        print(device.active_preset_data)
        --print("device.presets")
        --rprint(device.presets)
        --print("device.parameters")
        --rprint(device.parameters)
        print("device.external_editor_available")
        print(device.external_editor_available)
        if device.external_editor_available then
            print("device.external_editor_visible")
            print(device.external_editor_visible)
        end
        print("device.device_path")
        print(device.device_path)
    end
end
function print_device_parameters()
    local device = renoise.song().selected_device
    if not device then
        print("no selected device")
    else
        for index, parameter in pairs(device.parameters) do
            print("-----------------------------------")
            print("parameter.name")
            print(parameter.name)
            print("parameter.polarity")
            print(parameter.polarity)
            print("parameter.value_min")
            print(parameter.value_min)
            print("parameter.value_max")
            print(parameter.value_max)
            print("parameter.value_quantum")
            print(parameter.value_quantum)
            print("parameter.value_default")
            print(parameter.value_default)
            print("parameter.time_quantum")
            print(parameter.time_quantum)
            print("parameter.is_automatable")
            print(parameter.is_automatable)
            print("parameter.is_automated")
            print(parameter.is_automated)
            print("parameter.is_midi_mapped")
            print(parameter.is_midi_mapped)
            print("parameter.show_in_mixer")
            print(parameter.show_in_mixer)
            print("parameter.value")
            print(parameter.value)
            print("parameter.value_string")
            print(parameter.value_string)
            print("-----------------------------------")
        end
    end
    print(device.active_preset_data)
end

function get_last_outgoing_device(track_index)
    --[[
    This function is a helper for the create_monitor_send_device function.
    This function returns the last "outgoing" device, its index in the current track.
    The last outgoing refers to the last point that is not muted out by a send that
    has it's "Mute source/Keep source" option set to "mute".
    The monitor device needs to be placed before THAT device.
    --]]
    --Init some variables for this function
    local track = renoise.song():track(track_index)
    local devices = track.devices
    local out_indexes = table.create()
    local last_index = nil
    --Map all possibilities into "out_indexes" -table
    --(sends and the trackvolpan)
    for index, device in ipairs(devices) do
        local function add_to_out_list()
            table.insert(out_indexes, index)
        end
        print(device.name)
        if index == 1 then
            --trackvolpan device with the postfx volume
            add_to_out_list()
        end
        if device.name == "#Send" then
            --all sends go here
            add_to_out_list()
        end
    end
    --Painfully seek if one of the sends in "out_indexes" has "Mute source"
    --Painfully, because the "Mute source" option is only available
    --through the device's "active_preset_data" xml. So one needs to
    --parse that mofo to extract the relevant info. *Sigh*
    for out_list_index, device_index in ipairs(out_indexes) do
        --out_list_index = just the order in out_list_table
        --device_index = actual index of the device in the track device list
        --Check if it's teh trackvolpan device
        local device = track:device(device_index)
        local pr_data = device.active_preset_data

        if device_index == 1 then
            --its the trackdevice!
            --print("trackdevice")
            last_index = 1
        else
            --print(pr_data)
            local dummy, cursor_s = string.find(pr_data, "%<MuteSource%>") 
            local cursor_e, dummy = string.find(pr_data, "%<%/MuteSource%>") 
            local mute_value = string.sub(pr_data, cursor_s+1, cursor_e-1)

            if mute_value == "true" then
                last_index = device_index
                break
            else
                --mute_value == "false"
                if out_list_index == #out_indexes then
                    --If the send is on last place,
                    --and it's set to 'keep source'
                    --then the last volume device is
                    --in fact the Track volume pan device (index 1)
                    last_index = 1
                end
            end
        end
    end

    --print("last out index: "..last_index)

    --Get the last device relevant vol setting
    local relevant_device = track:device(last_index)

    return relevant_device, last_index
end


idle_update = function()
    --follow selected
    if is_active then
        if follow_selected_track then
            if renoise.song().selected_track_index ~= current_track then
                --delete previous
                delete_monitor_send_device(current_track)
                --print("deleted at trak "..current_track)
                create_monitor_send_device(renoise.song().selected_track_index)
                --print("created at trak "..renoise.song().selected_track_index)
            end
        end
    end
end



--------------------------------------------------------------------------------
-- GUI
--------------------------------------------------------------------------------

--[[
local function show_dialog()

  -- This block makes sure a non-modal dialog is shown once.
  -- If the dialog is already opened, it will be focused.
  if dialog and dialog.visible then
    dialog:show()
    return
  end
  
  -- The ViewBuilder is the basis
  vb = renoise.ViewBuilder()
  
  -- The content of the dialog, built with the ViewBuilder.
  local content = vb:column {
    margin = 10,
    vb:text {
      text = get_greeting()
    }
  } 
  
  -- A custom dialog is non-modal and displays a user designed
  -- layout built with the ViewBuilder.   
  dialog = renoise.app():show_custom_dialog(tool_name, content)  
  
end
--]]


--------------------------------------------------------------------------------
-- Menu entries
--------------------------------------------------------------------------------

--[[
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:"..tool_name.." - Create send",
  invoke = create_monitor_send_track
}
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:"..tool_name.." - Delete send",
  invoke = delete_monitor_send_track
}
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:"..tool_name.." - Move send track to last place",
  invoke = move_send_track_to_last_place
}
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:"..tool_name.." - Create device",
  invoke = function()
      create_monitor_send_device(renoise.song().selected_track_index)
  end
}
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:"..tool_name.." - Delete device",
  invoke = function()
      delete_monitor_send_device(renoise.song().selected_track_index)
  end
}
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:"..tool_name.." - Move send device to last place",
  invoke = function()
      move_send_device_to_last_place(renoise.song().selected_track_index)
    end
}
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:"..tool_name.." - Print devices",
  invoke = print_devices
}
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:"..tool_name.." - Print device parameters",
  invoke = print_device_parameters
}
--]]


--------------------------------------------------------------------------------
-- Key Binding
--------------------------------------------------------------------------------

renoise.tool():add_keybinding {
  name = "Mixer:Track Control:Monitor - Init",
  invoke = init
}

renoise.tool():add_keybinding {
  name = "Mixer:Track Control:Monitor - Exit",
  invoke = exit
}

--[[
--debugging
renoise.tool():add_keybinding {
  name = "Mixer:Track Control:Monitor - debug move sendtrack to last",
  invoke = move_send_track_to_last_place
}
--]]

--------------------------------------------------------------------------------
-- MIDI Mapping
--------------------------------------------------------------------------------

--[[
renoise.tool():add_midi_mapping {
  name = tool_id..":Show Dialog...",
  invoke = show_dialog
}
--]]
